using ExpressionExecutorCuda
using Test

const baseFolder = dirname(dirname(pathof(ExpressionExecutorCuda)))
include(joinpath(baseFolder, "src", "Utils.jl"))
include(joinpath(baseFolder, "src", "ExpressionProcessing.jl"))
include(joinpath(baseFolder, "src", "Interpreter.jl"))
include(joinpath(baseFolder, "src", "Transpiler.jl"))

@testset "ExpressionExecutorCuda.jl" begin
	# include("ExpressionProcessingTests.jl")
	# include("InterpreterTests.jl")
	include("TranspilerTests.jl")
end


#@testset "CPU Interpreter" begin
#	include("CpuInterpreterTests.jl")
#end

@testset "Performance tests" begin
	# TODO: make performance tests

	# Put data in shared memory: 
	# https://cuda.juliagpu.org/v2.6/api/kernel/#Shared-memory

	# Make array const:
	# https://cuda.juliagpu.org/v2.6/api/kernel/#Device-arrays

	# Memory management like in C++ might help with performance improvements
	# https://cuda.juliagpu.org/v2.6/lib/driver/#Memory-Management

	
end